import { Config, RuleConfigValue, VerifiedResult } from '@markuplint/ml-config';
import { Document, MLRule, Ruleset } from '@markuplint/ml-core';
import { MLMLSpec } from '@markuplint/ml-spec';
export declare function verify(html: string, config: Config, rules: MLRule<RuleConfigValue, unknown>[], locale?: string): Promise<VerifiedResult[]>;
export declare function fix(html: string, config: Config, rules: MLRule<RuleConfigValue, unknown>[], locale?: string): Promise<string>;
export interface MLCLIOption {
    /**
     * Glob pattern
     */
    files?: string;
    /**
     * Target source code of evaluation
     */
    sourceCodes?: string | string[];
    /**
     * File names of `sourceCodes`
     */
    names?: string | string[];
    workspace?: string;
    config?: string | Config;
    specs?: string | MLMLSpec;
    rules?: MLRule<RuleConfigValue, unknown>[];
    rulesAutoResolve?: boolean;
    locale?: string;
    fix?: boolean;
}
export declare function exec(options: MLCLIOption): Promise<MLResultInfo[]>;
interface MLResultInfo {
    results: VerifiedResult[];
    filePath: string;
    sourceCode: string;
    fixedCode: string;
    document: Document<any, unknown>;
    parser: string;
    locale?: string;
    ruleset: Ruleset;
    configSet: {
        config: Config;
        files: string[];
        error: string[];
    };
}
export {};
