"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var file_resolver_1 = require("@markuplint/file-resolver");
var ml_core_1 = require("@markuplint/ml-core");
var get_messenger_1 = require("./get-messenger");
var module_auto_loader_1 = require("./module-auto-loader");
var path_1 = __importDefault(require("path"));
var util_1 = require("./util");
function verify(html, config, rules, locale) {
    return __awaiter(this, void 0, void 0, function () {
        var totalResults;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec({
                        sourceCodes: html,
                        config: config,
                        rules: rules,
                        rulesAutoResolve: true,
                        locale: locale,
                    })];
                case 1:
                    totalResults = _a.sent();
                    return [2 /*return*/, totalResults[0] ? totalResults[0].results : []];
            }
        });
    });
}
exports.verify = verify;
function fix(html, config, rules, locale) {
    return __awaiter(this, void 0, void 0, function () {
        var totalResults, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exec({
                        sourceCodes: html,
                        config: config,
                        rules: rules,
                        locale: locale,
                        rulesAutoResolve: true,
                        fix: true,
                    })];
                case 1:
                    totalResults = _a.sent();
                    result = totalResults[0];
                    if (!result) {
                        return [2 /*return*/, html];
                    }
                    return [2 /*return*/, result.fixedCode];
            }
        });
    });
}
exports.fix = fix;
function exec(options) {
    return __awaiter(this, void 0, void 0, function () {
        var files, _a, _b, _c, codes, names_1, configs, configSet, filePath, _files, _i, files_1, file, configSetNearbyCWD, _d, files_2, file, configSet, specs, json, rules, r, totalResults, _e, files_3, file, configSet, parserModName, _f, _g, pattern, parser, ruleset, additionalRules, sourceCode, messenger, core, results;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    files = [];
                    if (!options.files) return [3 /*break*/, 2];
                    _b = (_a = files.push).apply;
                    _c = [files];
                    return [4 /*yield*/, file_resolver_1.getFiles(options.files)];
                case 1:
                    _b.apply(_a, _c.concat([(_h.sent())]));
                    if (!files.length) {
                        throw new Error("\"" + options.files + "\" is not found.");
                    }
                    return [3 /*break*/, 3];
                case 2:
                    if (options.sourceCodes) {
                        codes = Array.isArray(options.sourceCodes) ? options.sourceCodes : [options.sourceCodes];
                        names_1 = Array.isArray(options.names) ? options.names : options.names ? [options.names] : [];
                        files.push.apply(files, codes.map(function (code, i) { return file_resolver_1.getAnonymousFile(code, options.workspace, names_1[i]); }));
                    }
                    _h.label = 3;
                case 3:
                    configs = new Map();
                    if (!options.config) return [3 /*break*/, 8];
                    configSet = void 0;
                    if (!(typeof options.config === 'string')) return [3 /*break*/, 5];
                    return [4 /*yield*/, file_resolver_1.loadConfigFile(options.config)];
                case 4:
                    configSet = _h.sent();
                    return [3 /*break*/, 7];
                case 5:
                    filePath = process.cwd() + "/__NO_FILE__";
                    _files = new Set([filePath]);
                    return [4 /*yield*/, file_resolver_1.recursiveLoad(options.config, filePath, _files, true)];
                case 6:
                    configSet = _h.sent();
                    _h.label = 7;
                case 7:
                    if (configSet) {
                        for (_i = 0, files_1 = files; _i < files_1.length; _i++) {
                            file = files_1[_i];
                            configs.set(file, configSet);
                        }
                    }
                    return [3 /*break*/, 15];
                case 8:
                    configSetNearbyCWD = void 0;
                    _d = 0, files_2 = files;
                    _h.label = 9;
                case 9:
                    if (!(_d < files_2.length)) return [3 /*break*/, 15];
                    file = files_2[_d];
                    return [4 /*yield*/, file_resolver_1.searchConfigFile(file.path)];
                case 10:
                    configSet = _h.sent();
                    if (!configSet) return [3 /*break*/, 11];
                    configs.set(file, configSet);
                    return [3 /*break*/, 14];
                case 11:
                    if (!!configSetNearbyCWD) return [3 /*break*/, 13];
                    return [4 /*yield*/, file_resolver_1.searchConfigFile(process.cwd())];
                case 12:
                    configSetNearbyCWD = _h.sent();
                    _h.label = 13;
                case 13:
                    if (configSetNearbyCWD) {
                        configs.set(file, configSetNearbyCWD);
                    }
                    _h.label = 14;
                case 14:
                    _d++;
                    return [3 /*break*/, 9];
                case 15:
                    if (!(typeof options.specs === 'string')) return [3 /*break*/, 17];
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(options.specs)); })];
                case 16:
                    specs = _h.sent();
                    return [3 /*break*/, 20];
                case 17:
                    if (!options.specs) return [3 /*break*/, 18];
                    specs = options.specs;
                    return [3 /*break*/, 20];
                case 18: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('@markuplint/html-ls')); })];
                case 19:
                    json = _h.sent();
                    // @ts-ignore
                    specs = json.default;
                    _h.label = 20;
                case 20:
                    if (!options.rules) return [3 /*break*/, 21];
                    rules = options.rules;
                    return [3 /*break*/, 23];
                case 21: return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require('@markuplint/rules')); })];
                case 22:
                    r = _h.sent();
                    rules = r.default;
                    _h.label = 23;
                case 23:
                    totalResults = [];
                    _e = 0, files_3 = files;
                    _h.label = 24;
                case 24:
                    if (!(_e < files_3.length)) return [3 /*break*/, 32];
                    file = files_3[_e];
                    configSet = configs.get(file) || {
                        config: {},
                        files: new Set(),
                        errs: [],
                    };
                    parserModName = '@markuplint/html-parser';
                    if (configSet.config.parser) {
                        for (_f = 0, _g = Object.keys(configSet.config.parser); _f < _g.length; _f++) {
                            pattern = _g[_f];
                            if (path_1.default.basename(file.path).match(util_1.toRegxp(pattern))) {
                                parserModName = configSet.config.parser[pattern];
                            }
                        }
                    }
                    return [4 /*yield*/, Promise.resolve().then(function () { return __importStar(require(parserModName)); })];
                case 25:
                    parser = _h.sent();
                    ruleset = ml_core_1.convertRuleset(configSet.config);
                    if (!options.rulesAutoResolve) return [3 /*break*/, 27];
                    return [4 /*yield*/, module_auto_loader_1.moduleAutoLoader(ruleset)];
                case 26:
                    additionalRules = (_h.sent()).rules;
                    rules = rules.concat.apply(rules, additionalRules);
                    _h.label = 27;
                case 27: return [4 /*yield*/, file.getContext()];
                case 28:
                    sourceCode = _h.sent();
                    return [4 /*yield*/, get_messenger_1.getMessenger(options.locale)];
                case 29:
                    messenger = _h.sent();
                    core = new ml_core_1.MLCore(parser, sourceCode, specs, ruleset, rules, messenger);
                    return [4 /*yield*/, core.verify(!!options.fix)];
                case 30:
                    results = _h.sent();
                    totalResults.push({
                        results: results,
                        filePath: file.path,
                        sourceCode: sourceCode,
                        fixedCode: core.document.toString(),
                        document: core.document,
                        parser: parserModName,
                        locale: options.locale,
                        ruleset: ruleset,
                        configSet: {
                            config: configSet.config,
                            files: Array.from(configSet.files),
                            error: configSet.errs.map(function (e) { return "" + e; }),
                        },
                    });
                    _h.label = 31;
                case 31:
                    _e++;
                    return [3 /*break*/, 24];
                case 32: return [2 /*return*/, totalResults];
            }
        });
    });
}
exports.exec = exec;
